from __future__ import print_function
import argparse
import logging

parser   = argparse.ArgumentParser()
add      = parser.add_argument
defaults = parser.set_defaults
parse    = parser.parse_args

add("--mpi_ni", type=int, default=1, help="number of x processors")
add("--mpi_nj", type=int, default=1, help="number of y processors")
add("--log",type=str,default='DEBUG',choices=('DEBUG', 'INFO', 'WARNING', 'ERROR', 'CRITICAL'),
                    help="Set verbosity level of logging")
add("--hydrostatic", action='store_true')
add("--llm", type=int)
add("--dt", type=float, help='Time step in seconds')
add("--debug", default=[], type=lambda str : str.split(','), 
    help='Comma-separated list of modules that will display debug information')

def noop(*args, **kwargs): pass

class Logger:
    debug, info, error = logging.debug, logging.info, logging.error
    def __init__(self, modulename):
        arglist = parser.parse_args()
        if modulename not in arglist.debug :
            self.debug = noop
        else:
            print('Debug ON for module %s'%modulename)

def config_log(**kwargs):
    arglist = parser.parse_args()
    loglevel = getattr(logging, arglist.log.upper())
    logging.basicConfig(level=loglevel, **kwargs)
